"use strict";

function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self);
}
function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
var Node = require("./Node");
function map(fn) {
  var MapNode = /*#__PURE__*/function (_Node) {
    _inherits(MapNode, _Node);
    var _super = _createSuper(MapNode);
    function MapNode(options, eventemitter) {
      var _this;
      _classCallCheck(this, MapNode);
      _this = _super.call(this, options, eventemitter);
      _this.fn = options;
      return _this;
    }
    _createClass(MapNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        var out = this.fn(signal);
        this.send(out);
      }
    }]);
    return MapNode;
  }(Node);
  return new MapNode(fn);
}
exports["map"] = map;
function filter(fn) {
  var FilterNode = /*#__PURE__*/function (_Node2) {
    _inherits(FilterNode, _Node2);
    var _super2 = _createSuper(FilterNode);
    function FilterNode(options, eventemitter) {
      var _this2;
      _classCallCheck(this, FilterNode);
      _this2 = _super2.call(this, options, eventemitter);
      _this2.fn = options;
      return _this2;
    }
    _createClass(FilterNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        if (fn(signal)) {
          this.send(signal);
        } else {
          // request next signal
          this.request();
        }
      }
    }]);
    return FilterNode;
  }(Node);
  return new FilterNode(fn);
}
exports["filter"] = filter;
function reduce(memo, iterator) {
  var ReduceNode = /*#__PURE__*/function (_Node3) {
    _inherits(ReduceNode, _Node3);
    var _super3 = _createSuper(ReduceNode);
    function ReduceNode(options, eventemitter) {
      var _this3;
      _classCallCheck(this, ReduceNode);
      _this3 = _super3.call(this, options, eventemitter);
      _this3.memo = _this3.options.memo;
      _this3.iterator = _this3.options.iterator;
      _this3.END = false;
      return _this3;
    }
    _createClass(ReduceNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        this.memo = this.iterator.call(this, this.memo, signal);
        this.request(); // back pressure call for next
      }
    }, {
      key: "onEnd",
      value: function onEnd() {
        this.send(this.memo);
        this.END = true;
      }
    }, {
      key: "onRequest",
      value: function onRequest(cmd) {
        if (!this.END) {
          this.request();
        } else {
          this.send(Node.END);
        }
      }
    }]);
    return ReduceNode;
  }(Node);
  return new ReduceNode({
    memo: memo,
    iterator: iterator
  });
}
exports["reduce"] = reduce;
function errors(fn) {
  var ErrorsNode = /*#__PURE__*/function (_Node4) {
    _inherits(ErrorsNode, _Node4);
    var _super4 = _createSuper(ErrorsNode);
    function ErrorsNode(options, eventemitter) {
      var _this4;
      _classCallCheck(this, ErrorsNode);
      _this4 = _super4.call(this, options, eventemitter);
      _this4.fn = options;
      return _this4;
    }
    _createClass(ErrorsNode, [{
      key: "onError",
      value: function onError(error) {
        var _this5 = this;
        this.fn(error, function (signal) {
          _this5.send(signal);
        });
      }
    }]);
    return ErrorsNode;
  }(Node);
  return new ErrorsNode(fn);
}
;
exports["errors"] = errors;
function sink() {
  var SinkNode = /*#__PURE__*/function (_Node5) {
    _inherits(SinkNode, _Node5);
    var _super5 = _createSuper(SinkNode);
    function SinkNode() {
      _classCallCheck(this, SinkNode);
      return _super5.apply(this, arguments);
    }
    _createClass(SinkNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        this.request();
      }
    }, {
      key: "from",
      value: function from(node) {
        this.request();
      }
    }]);
    return SinkNode;
  }(Node);
  return new SinkNode();
}
;
exports["sink"] = sink;
function throttle(ms) {
  var last = new Date().getTime();
  var ThrottleNode = /*#__PURE__*/function (_Node6) {
    _inherits(ThrottleNode, _Node6);
    var _super6 = _createSuper(ThrottleNode);
    function ThrottleNode() {
      _classCallCheck(this, ThrottleNode);
      return _super6.apply(this, arguments);
    }
    _createClass(ThrottleNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        var now = new Date().getTime();
        if (now - ms >= last) {
          last = now;
          this.send(signal);
        }
      }
    }]);
    return ThrottleNode;
  }(Node);
  return new ThrottleNode(ms);
}
;
exports["throttle"] = throttle;
function scan(n, add) {
  var ScanNode = /*#__PURE__*/function (_Node7) {
    _inherits(ScanNode, _Node7);
    var _super7 = _createSuper(ScanNode);
    function ScanNode(options, eventemitter) {
      var _this6;
      _classCallCheck(this, ScanNode);
      _this6 = _super7.call(this, options, eventemitter);
      _this6.n = options.n;
      _this6.add = options.add;
      return _this6;
    }
    _createClass(ScanNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        this.n = this.add.call(this, this.n, signal);
        this.send(this.n);
      }
    }]);
    return ScanNode;
  }(Node);
  return new ScanNode({
    n: n,
    add: add
  });
}
;
exports["scan"] = scan;
function act(fn) {
  var ActNode = /*#__PURE__*/function (_Node8) {
    _inherits(ActNode, _Node8);
    var _super8 = _createSuper(ActNode);
    function ActNode(options, eventemitter) {
      var _this7;
      _classCallCheck(this, ActNode);
      _this7 = _super8.call(this, options, eventemitter);
      _this7.fn = options;
      return _this7;
    }
    _createClass(ActNode, [{
      key: "onSignal",
      value: function onSignal(signal) {
        this.fn(signal);
        this.send(signal);
      }
    }]);
    return ActNode;
  }(Node);
  return new ActNode(fn);
}
exports["act"] = act;
function done(fn) {
  var DoneNode = /*#__PURE__*/function (_Node9) {
    _inherits(DoneNode, _Node9);
    var _super9 = _createSuper(DoneNode);
    function DoneNode(options, eventemitter) {
      var _this8;
      _classCallCheck(this, DoneNode);
      _this8 = _super9.call(this, options, eventemitter);
      _this8.fn = options;
      return _this8;
    }
    _createClass(DoneNode, [{
      key: "onEnd",
      value: function onEnd(signal) {
        this.fn(signal);
      }
    }]);
    return DoneNode;
  }(Node);
  return new DoneNode(fn);
}
exports["done"] = done;